// ::::::::::::::
// DrawCanvas.java
// ::::::::::::::
import java.awt.*;
import java.applet.*;
import java.util.StringTokenizer;

public class DrawCanvas extends Canvas {

	Paint applet;
	Graphics g;
	String curMode="Rect";
	mPoint curObj;
	public boolean fill=true;
	mCursor cursor;
	mPoint objList[]=new mPoint[100];
	int index=0;

	public DrawCanvas(Paint applet) {
		
		setBackground(Color.blue);
		setForeground(Color.yellow);
		this.applet = applet;
		cursor = new mCursor();
	} 

	public void setDrawMode(String s) {
		if(s.equals("Clear")) {
			index=0;
			repaint();
		} else if(s.equals("Redraw")) repaint();
		else curMode=s;
	}

	public void paint(Graphics g) {

		g.setColor(Color.yellow);
		super.paint(g);
		for(int i=0; i<index; i++)
			objList[i].draw(g);
		cursor.draw(g);
	}

	public boolean mouseDown(Event e, int x, int y) {		
/*TANGO*/	if (applet.isMaster())
/*TANGO*/   		applet.tangoSend("mouseDown "+Integer.toString(x)+" "+Integer.toString(y));
/*TANGO*/	else if (applet.isMyOwnAction()) return true;

		if (curMode.equals("Rect")) curObj=new mRectangle(x, y, x, y);
		else if (curMode.equals("Circ")) curObj=new mCircle(x, y, x, y);
		else if (curMode.equals("Line")) curObj=new mLine(x, y, x+1, y+1);
		else if (curMode.equals("Round")) curObj=new mRound(x, y, x, y);
		return true;
	}

	public boolean mouseDrag(Event e, int x, int y) {
/*TANGO*/	if (applet.isMaster())
/*TANGO*/   		applet.tangoSend("mouseDrag "+Integer.toString(x)+" "+Integer.toString(y));
/*TANGO*/	else if (applet.isMyOwnAction()) return true;

		g=getGraphics();
		g.setXORMode(Color.black);
		cursor.draw(g);
		curObj.draw(g);
		cursor.move(x, y);
		curObj.setEnds(x, y);
		cursor.draw(g);
		curObj.draw(g);
		return true;
	}

	public boolean mouseUp(Event e, int x, int y) {		
/*TANGO*/	if (applet.isMaster())
/*TANGO*/   		applet.tangoSend("mouseUp "+Integer.toString(x)+" "+Integer.toString(y));
/*TANGO*/	else if (applet.isMyOwnAction()) return true;

		g=getGraphics();
		g.setPaintMode();
		curObj.setEnds(x, y);
		curObj.setFill(fill);
		objList[index++]=curObj;
		curObj.draw(g);
		if(index>=100) index=100;

		return true;
	}

	public boolean mouseMove(Event e, int x, int y) {
/*TANGO*/	if (applet.isMaster())
/*TANGO*/   		applet.tangoSend("mouseMove "+Integer.toString(x)+" "+Integer.toString(y));
/*TANGO*/	else if (applet.isMyOwnAction()) return true;

		g=getGraphics();
		g.setXORMode(Color.black);
		cursor.draw(g);
		cursor.move(x, y);
		cursor.draw(g);

		return true;
	}

	public void sendObjects() {

		String msg = "objects";
		for(int i=0; i<index; i++) 
			msg += " " + objList[i].toString();

		msg += " " + cursor.toString();
		msg += " curMode " + curMode;
		msg += " fill " + String.valueOf( fill );
		msg += " eom";

		applet.tangoSend( msg );
	}

	public void getObjects(StringTokenizer st) {

		index = 0;

		String type = st.nextToken();
		while ( !type.equals("eom") && st.hasMoreElements()) {
		  if (type.equals("curMode")) {
		    curMode = st.nextToken();
		  } else if(type.equals("fill")) {
		    fill = (st.nextToken().equals("true")) ? true:false;
		    if(fill) applet.action( null, "Fill" );
		    else applet.action( null, "Draw" );
		  } else {
		     int x = Integer.parseInt( st.nextToken() );
		     int y = Integer.parseInt( st.nextToken() );
		     int x2= Integer.parseInt( st.nextToken() );
		     int y2= Integer.parseInt( st.nextToken() );
		     boolean fill = (st.nextToken().equals("true")) ? true:false;
		     if(type.equals("Cursor"))
			cursor = new mCursor(x,y,x2,y2);
		     else {
			if(type.equals("Point")) 
				objList[index] = new mPoint(x,y,x2,y2);
			else if(type.equals("Line")) 
				objList[index] = new mLine(x,y,x2,y2);
			else if(type.equals("Rectangle")) 
				objList[index] = new mRectangle(x,y,x2,y2);
			else if(type.equals("Round")) 
				objList[index] = new mRound(x,y,x2,y2);
			else if(type.equals("Circle")) 
				objList[index] = new mCircle(x,y,x2,y2);
			objList[index++].setFill(fill);			
		     }
		   }
		   type = st.nextToken();
		}
		if( !type.equals("eom") ) {
			System.out.println("Error: Object list not received correctly.");
		  }
		  repaint();
	}
}
