// ::::::::::::::
// Paint.java
// ::::::::::::::

/*TANGO*/    // TANGO API classes for collaborative framework
/*TANGO*/    import interfaces.AppletBase;
/*TANGO*/    import messages.*;
/*TANGO*/    import consts.*;

import java.awt.*;
import java.applet.*;
import java.util.Hashtable;
import java.util.StringTokenizer;

/* removed */ //public class Paint extends Applet {

/*TANGO*/ public class Paint extends AppletBase {
/*TANGO*/   boolean Master = true;   // to indicate master/slave status
/*TANGO*/   boolean myOwnAction = true;   // to indicate master/slave status

	Label Status;
	DrawCanvas c;
	Hashtable buttons;	
	
    public void init() {
/*TANGO*/      register();   // TANGO registration, 
/*TANGO*/                    //this is the first method called in init method

	setLayout(new BorderLayout());

	setBackground(Color.gray);
	setForeground(Color.black);

	Panel w=new Panel();
	w.setLayout(new GridLayout(7,0));

	buttons = new Hashtable();
	buttons.put("Rect",  new Button("Rect"));
	buttons.put("Round", new Button("Round"));
	buttons.put("Circ",  new Button("Circ"));
	buttons.put("Line",  new Button("Line"));
	buttons.put("Draw",  new Button("Draw"));
	buttons.put("Redraw",new Button("Redraw"));
	buttons.put("Clear", new Button("Clear"));

	w.add( (Button)buttons.get("Rect") );
	w.add( (Button)buttons.get("Round") );
	w.add( (Button)buttons.get("Circ") );
	w.add( (Button)buttons.get("Line") );
	w.add( (Button)buttons.get("Draw") );
	w.add( (Button)buttons.get("Redraw") );
 	w.add( (Button)buttons.get("Clear") );

	add("West", w);

	Status=new Label("Status Line");
	Panel p=new Panel();
	p.setBackground(Color.gray);
	p.add(Status);
	add("South",p);

	c=new DrawCanvas(this);
	c.setBackground(Color.blue);
	add("Center", c);

	System.out.println("Is master:" + String.valueOf( isMaster() ));
	if(!Master) tangoSend("get_objects");
    }

     public void paint(Graphics g) {
		c.paint(g);
     }

     public boolean action(Event evt, Object arg) {

	String s=(String) arg;

/*TANGO*/ if (Master) {
/*TANGO*/    	  tangoSend("button "+s);
/*TANGO*/    	  }
/*TANGO*/    else if (myOwnAction) {
/*TANGO*/      return true;
/*TANGO*/    }

       		Status.setText(s);
		if (s.equals("Draw")) {
			((Button)buttons.get("Draw")).setLabel("Fill");
			c.fill=false;
		} else if (s.equals("Fill")) {
			((Button)buttons.get("Draw")).setLabel("Draw");
			c.fill=true;
		} else c.setDrawMode(s);

	return true;
    }

    public boolean isMaster() { return Master; }
    public boolean isMyOwnAction() { return myOwnAction; }

/*TANGO*/    public void tangoSend(String str)  {
/*TANGO*/            /* Send events over TANGO */
/*TANGO*/              int len=str.length();
/*TANGO*/              // prepare message to be sent by TANGO runtime
/*TANGO*/              byte[] t=new byte[len];
/*TANGO*/              str.getBytes(0,len,t,0);
/*TANGO*/             AppEventMessage em=new AppEventMessage(Const.DATA,t);
/*TANGO*/             send(em); 
/*TANGO*/    }

/*TANGO*/    // recieve events from Mater (Slave Only), this method is required
/*TANGO*/    public void receive (AppEventMessage em) {
/*TANGO*/      try {
/*TANGO*/          // by default, when a new instance joins, it gets an master/slave message
/*TANGO*/           if (em.getType() == Const.CONTROL) {
/*TANGO*/                    CAppAnswerEventMessage msg =  (CAppAnswerEventMessage) em;
/*TANGO*/                    if (msg.getAnswerType() == CAConsts.ISMASTER) {
/*TANGO*/                            Master = msg.isMaster(); // update master/slave status
/*TANGO*/                            if (Master) {
/*TANGO*/				System.out.println("I am the Sender now.");
/*TANGO*/			     } else {
/*TANGO*/ 				System.out.println("I am the Receiver now.");
/*TANGO*/			     }
/*TANGO*/                    }
/*TANGO*/                    return;
/*TANGO*/          }
/*TANGO*/          myOwnAction=false;
/*TANGO*/          // slave decides what to do upon the event received  from the master
/*TANGO*/          String msg=new String(em.getData(),0,0,em.getLen()); // decode the message into a String
/*TANGO*/          StringTokenizer tokens = new StringTokenizer( msg );
/*TANGO*/          
/*TANGO*/          String command = tokens.nextToken();
/*TANGO*/          if( command.equals("button") ) {
/*TANGO*/          	// a button is hit
/*TANGO*/          	action( null, tokens.nextToken() );
/*TANGO*/          } else if( command.startsWith("mouse")) {
/*TANGO*/          	// otherwise it is a mouse event.
/*TANGO*/          	int x = Integer.parseInt( tokens.nextToken() );
/*TANGO*/          	int y = Integer.parseInt( tokens.nextToken() );
/*TANGO*/		if( command.equals("mouseDown") ) 
/*TANGO*/          		c.mouseDown(null, x, y );
/*TANGO*/          	else if ( command.equals("mouseDrag") )
/*TANGO*/          		c.mouseDrag(null, x, y );
/*TANGO*/          	else if ( command.equals("mouseUp") )
/*TANGO*/          		c.mouseUp(null, x, y );
/*TANGO*/          } else if( command.equals("get_objects")) {
/*TANGO*/		c.sendObjects();
/*TANGO*/	   } else if( command.equals("objects")) {
/*TANGO*/		c.getObjects( tokens );
/*TANGO*/	   }
/*TANGO*/          
/*TANGO*/          myOwnAction=true;
/*TANGO*/      }
/*TANGO*/      catch (Exception e) {
/*TANGO*/        e.printStackTrace();
/*TANGO*/      }
/*TANGO*/    }
}

